<?php
/***********************************************************************

  Copyright (C) 2006  guardian34 (publicbox@fmguy.com)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
	exit;

// Tell admin_loader.php that this is indeed a plugin and that it is loaded
define('PUN_PLUGIN_LOADED', 1);

if (isset($_POST['update']))
{
	// Make sure post id was entered
	if (trim($_POST['post_id']) == '')
		message('You didn\'t enter a post id!');

	// Make sure user id was entered
	if (trim($_POST['user_id']) == '')
		message('You didn\'t enter an user id!');

	$post_id = intval($_POST['post_id']);
	$user_id = intval($_POST['user_id']);

	// Get new username
	$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE id = '.$user_id);
	$new_user = $db->result($result, 0);
	if ($new_user == '')
		message('User id '.$user_id.' wasn\'t found.');
		
	// Update post
	$db->query('UPDATE '.$db->prefix.'posts SET poster=\''.$new_user.'\', '.'poster_id='.$user_id.' WHERE id = '.$post_id);
	if ($db->affected_rows() < 1)
		$results = 'The post author was <b>not</b> updated.<br />'."\n\t\t\t\t";
	else
		$results = 'The post author was updated successfully. '.
			'(Post: <a href="viewtopic.php?pid='.$post_id.'">'.$post_id.'</a>;'.
			' User: <a href="profile.php?id='.$user_id.'">'.$user_id.'</a>)<br />'."\n\t\t\t\t";

	// Optionally update topic and forum information
	if (isset($_POST['up_poster']) || isset($_POST['up_last_poster']))
	{
		$result = $db->query('SELECT topic_id FROM '.$db->prefix.'posts WHERE id = '.$post_id);
		$topic_id = $db->result($result, 0);
	
		if (isset($_POST['up_poster']))
		{
			$result = $db->query('UPDATE '.$db->prefix.'topics SET poster = \''.$new_user.'\' WHERE id = '.$topic_id);
			if ($db->affected_rows() < 1)
				$results .= 'The topic poster was <b>not</b> updated.<br />';
			else
				$results .= 'The topic poster was updated successfully.<br />';
		}
		if (isset($_POST['up_last_poster']))
		{
			$result = $db->query('UPDATE '.$db->prefix.'topics SET last_poster = \''.$new_user.'\' WHERE last_post_id = '.$post_id);
			if ($db->affected_rows() < 1)
				$results .= 'The topic last poster was <b>not</b> updated.';
			else
				$results .= 'The topic last poster was updated successfully.';

			$result = $db->query('SELECT forum_id FROM '.$db->prefix.'topics WHERE id = '.$topic_id);
			update_forum($db->result($result, 0));
		}
	}

	// Display the admin navigation menu
	generate_admin_menu($plugin);
?>
	<div class="block">
		<h2><span>Post Author Update - v1.0</span></h2>
		<div class="box">
			<div class="inbox">
				<p>This plugin modifies a post's author.</p>
			</div>
		</div>
	</div>
		
	<div class="block">
		<h2 class="block2"><span>Result</span></h2>
		<div class="box">
			<div class="inbox">
				<p><?php echo $results; ?></p>
			</div>
		</div>
	</div>
<?php
}
else
{
	// Display the admin navigation menu
	generate_admin_menu($plugin);
?>
	<div class="block">
		<h2><span>Post Author Update - v1.0</span></h2>
		<div class="box">
			<div class="inbox">
				<p>This plugin modifies a post's author.</p>
			</div>
		</div>
	</div>
		
	<div class="blockform">
		<h2 class="block2"><span>Input</span></h2>
		<div class="box">
			<form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
				<div class="inform">
					<fieldset>
						<legend>IDs</legend>
						<div class="infldset">
							<table class="aligntop" cellspacing="0">
								<tr>
									<th scope="row">Post ID:</th>
									<td><input type="text" name="post_id" size="16" tabindex="1" /></td>
								</tr>
								<tr>
									<th scope="row">User ID:</th>
									<td><input type="text" name="user_id" size="16" tabindex="2" /></td>
								</tr>
							</table>
						</div>
					</fieldset>
				</div>
				<div class="inform">
					<fieldset>
						<legend>Optional Actions</legend>
						<div class="infldset">
							<p><input type="checkbox" tabindex="4" name="up_poster" />Update topic poster</p>
							<p><input type="checkbox" tabindex="5" name="up_last_poster" />Update topic last poster</p>
						</div>
					</fieldset>
				</div>
			<p class="submitend"><input type="submit" name="update" value="Update" tabindex="6" /></p>
			</form>
		</div>
	</div>
<?php
}
?>